# netstat mysql tables - v3.0
# you must have already installed and running netacct-mysql >= 0.74
# default user admin with pass admin added at the end
# if you want you can change something bellow
#

USE netacct;


#
# Table structure for table `ipallow`
#

CREATE TABLE IF NOT EXISTS ipallow (
  ip varchar(15) NOT NULL default '',
  PRIMARY KEY  (ip)
) TYPE=MyISAM;
# --------------------------------------------------------

#
# Table structure for table `logins`
#

CREATE TABLE IF NOT EXISTS logins (
  uid int(10) unsigned NOT NULL default '0',
  date datetime NOT NULL default '0000-00-00 00:00:00',
  ip char(20) NOT NULL default '',
  PRIMARY KEY  (uid,date)
) TYPE=MyISAM;
# --------------------------------------------------------


#
# Table structure for table `users`
#

CREATE TABLE IF NOT EXISTS users (
  uid int(10) NOT NULL auto_increment,
  ip varchar(15) default '0',
  login varchar(15) NOT NULL default '',
  password varchar(35) NOT NULL default '',
  status enum('client','pclient','admin') NOT NULL default 'client',
  input_traffic_price float(5,2) unsigned default '0.00',
  output_traffic_price float(5,2) unsigned default '0.00',
  input_peering_price float(5,2) unsigned default '0.00',
  output_peering_price float(5,2) unsigned default '0.00',
  input_direct_price float(5,2) unsigned default '0.00',
  output_direct_price float(5,2) unsigned default '0.00',
  input_local_price float(5,2) unsigned default '0.00',
  output_local_price float(5,2) unsigned default '0.00',
  PRIMARY KEY  (uid,login),
  UNIQUE KEY login (login),
  UNIQUE KEY uid (uid)
) TYPE=MyISAM;

ALTER TABLE users DROP `ip`;

# --------------------------------------------------------

#
# Table structure for table `users_ip`
#

CREATE TABLE IF NOT EXISTS users_ip (
  ipid bigint(40) NOT NULL auto_increment,
  uid int(10) NOT NULL default '0',
  ip varchar(15) NOT NULL default '',
  PRIMARY KEY  (ipid),
  KEY uid (uid)
) TYPE=MyISAM;


GRANT delete ON netacct.* TO acct@localhost ;
INSERT INTO users (login, password, status) VALUES ('admin', '21232f297a57a5a743894a0e4a801fc3', 'admin');
INSERT INTO ipallow (ip) VALUES ('127.0.0.1');
