<?php
  // 
  // This software and all associated files are released under the 
  // GNU General Public License, see http://www.gnu.org/copyleft/gpl.txt
  //
  // This software is designed to analyze data collected by Net Acct mySQL,
  // see http://sourceforge.net/projects/netacct-mysql/
  //
  // If you do modifications or optimzations to this software, please contact
  // the project coordinator at <sebastian@nohn.net>
  //
  // see project homepage http://nohn.net/projects/nacct-php for updates
  //
  // The initial developer of this software is Sebastian Nohn
  // <sebastian@nohn.net>
  //

  $subnet           = "192.168.100";        // change this to your local subnet
  $db_host          = "localhost";          // change this to your mysql-server
  $db_user          = "acct";               // change this to your mysql-user
  $db_password      = "acct_password";      // change this to your mysql-password
  $db               = "netacct";            // change this to your database
  $db_table         = "accounting";         // change this to your database-table
  $cache_time       = "3600";               // how long should forms be cached? (seconds)
  $result_cachetime = "31536000";           // how long should results be cached? (seconds)
  $cache_dir        = "cache/";             // set to any webserver-writable directory
  $include_path     = "/usr/local/lib/php"; // change this to your PEAR directory. see README

  // don`t change anything below this if you`re not knowing what you do

  function getmicrotime() {
    $mtime = microtime();
    $mtime = explode(" ",$mtime);
    $mtime = $mtime[1] + $mtime[0];
    return ($mtime);
  }

  $start = getmicrotime();

  ini_set("include_path","$include_path");

  // some definitons
  $traffictag = 0;
  $traffictag_name = array("Byte","KByte","MByte","GByte","TByte");

  require_once("Cache.php");

  // connect to database
  $db_connection = mysql_connect("$db_host","$db_user","$db_password");
  mysql_select_db("$db");

  //
  // base functions
  //

  // draw the <option> tags for a date selector
  function f_datelist() {
    global $db_table, $cache_time, $cache_dir;
    $query_f_datelist  = "SELECT data FROM $db_table GROUP BY data";
    $date_cache = new Cache("file", array("cache_dir" => "$cache_dir"));
    $date_cache_id = $date_cache->generateID("query_f_datelists");
    if ($date_content = $date_cache->get($date_cache_id)) {
      $datelist = $date_content;
    } else {
      $result_f_datelist = mysql_query("$query_f_datelist");
      while ($row_f_datelist = mysql_fetch_array($result_f_datelist)) {
        $date_content .= "<option value=\"$row_f_datelist[data]\">$row_f_datelist[data]";
      }
      $date_cache->save($date_cache_id, $date_content, $cache_time);
      $datelist = $date_cache->get($date_cache_id);
    }
    echo "$datelist";
  }

  // draw the <option> tags for a ip selector 
  function f_iplist() {
    global $subnet, $db_table, $cache_time, $cache_dir;
    $query_f_iplist = "SELECT src_ip FROM $db_table WHERE src_ip LIKE \"$subnet.%\" GROUP BY src_ip ORDER BY src_ip";
    $ip_cache = new Cache("file", array("cache_dir" => "$cache_dir"));
    $ip_cache_id = $ip_cache->generateID("query_f_iplist");
    if ($ip_content = $ip_cache->get($ip_cache_id)) {
      $iplist = $ip_content;
    } else {
      $result_f_iplist = mysql_query("$query_f_iplist");
      while ($row_f_iplist = mysql_fetch_array($result_f_iplist)) {
        $ip_content .= ("<option value=\"$row_f_iplist[src_ip]\">$row_f_iplist[src_ip]");
      }
      $ip_cache->save($ip_cache_id, $ip_content, $cache_time);
      $iplist = $ip_cache->get($ip_cache_id);
    }
    echo "$iplist";
  }

  // generate stats
  function genstats($query_stats) {
    $result_stats = mysql_query($query_stats);
    $totaltraffic = mysql_result($result_stats,0,"SUM(data_size)");
    return $totaltraffic;
  }

  //
  // main code
  //

  if ($action == "calculate") {

  //
  // build the query 
  //

  $query_stats = "SELECT SUM(data_size) FROM $db_table WHERE 1=1";

  // hostrange and type 
  if ($f_host_start == $f_host_end) {
    switch ($f_type) {
      case "incoming":
        $query_stats .= " AND dst_ip >= \"$f_host_start\" AND dst_ip <= \"$f_host_start\"";
        break;
      case "outgoing":
        $query_stats .= " AND src_ip >= \"$f_host_start\" AND src_ip <= \"$f_host_start\"";
        break;
      case "in/out":
        $query_stats .= " AND (src_ip = \"$f_host_start\" OR dst_ip = \"$f_host_start\")";
        break;
    }
  } else {
    $host_start_array = explode(".",$f_host_start);
    $host_start = $host_start_array[3];

    $host_end_array = explode(".",$f_host_end);
    $host_end = $host_end_array[3];

    $host_current = $host_start;
    $host_current_all = "\"0.0.0.0\"";
    while ($host_current <= $host_end) {
      $host_current_all .= ",\"$subnet.$host_current\"";
      $host_current++;
    }
    switch ($f_type) {
      case "incoming":
        $query_stats .= " AND dst_ip IN ($host_current_all)";
        break;
      case "outgoing":
        $query_stats .= " AND src_ip IN ($host_current_all)";
        break;
      case "in/out":
        $query_stats .= " AND (src_ip IN ($host_current_all) OR dst_ip IN ($host_current_all))";
        break;
    }
  }

  // protocol
  switch($f_protocol) {
    case "TCP":
      $query_stats .= " AND protocol=\"6\"";
      break;
    case "ICMP":
      $query_stats .= " AND protocol=\"1\"";
      break;
    case "UDP":
      $query_stats .= " AND protocol=\"17\"";
      break;
    case "OSPF":
      $query_stats .= " AND protocol=\"89\"";
      break;
  }
  
  switch($f_peer) {
    case "onlypeer":
      $query_stats .= " AND peer=\"1\"";
      break;
    case "nopeer":
      $query_stats .= " AND peer=\"0\"";
      break;
  }  
  
  // timeframe
  if ($f_date_min) {
   $query_stats .= " AND data BETWEEN \"$f_date_min\" AND \"$f_date_max\"";
  }

  //
  // get the results
  //

  // check if the user is requesting "old" data
  $today = date("Y-m-d");
  if ($f_date_max < $today) {
    // check if data is cached
    $cache = new Cache("file", array("cache_dir" => "$cache_dir"));
    $cache_id = $cache->generateID("$query_stats");
    if ($content = $cache->get($cache_id)) {
      $totaltraffic = $content;
      $cached = " - <font color=\"green\">Cache Hit</font>";
    } else {
      // generate content
      $contents = genstats($query_stats);
      $cache->save($cache_id, $contents, $result_cachetime);
      $totaltraffic = $cache->get($cache_id);
      $cached = " - <font color=\"red\">Cache Miss</font>";
    }
  } else {
    // user is requesting data that may change, so do not cache
    $totaltraffic = genstats($query_stats);
    $cached = " - <font color=\"red\">Not cached</font>";    
  }

  while ((floor($totaltraffic/1024)) > 0) {
    $totaltraffic = $totaltraffic/1024;
    $traffictag++;
  }
  $totaltraffic = round($totaltraffic,2);
  $totaltraffic .= " $traffictag_name[$traffictag]";
  while ((floor($totaltraffic/1024)) > 0) {
    $totaltraffic = $totaltraffic/1024;
    $traffictag++;
  }
  $totaltraffic = round($totaltraffic,2);
  $totaltraffic .= " $traffictag_name[$traffictag]";
  }
?>
<html>
<head>
<title>netacct stats</title>
<style type="text/css">
<!--
  BODY, P, DIV, TD, FORM {
    font-family: sans-serif;
    font-size: 12pt;
    color: #000000;
    background: #dfdfdf;
  }
  .thead {
    font-weight: bold;
  }
  .small {
   font-size:10pt;
  }
-->
</style>
</head>
<body>
<table border="0">
<form action="<?php echo $PHP_SELF; ?>" method="get">
<input type="hidden" name="action" value="calculate">

  <tr>
    <td class="thead">Hostrange</td>
    <td>
      From
    </td>
    <td>
      <select name="f_host_start">
      <?php
        f_iplist();
      ?>
      </select>
    </td>
    <td>
      To
    </td>
    <td>
      <select name="f_host_end">
      <?php
        f_iplist();
      ?>
      </select>
    </td>
  </tr>

  <tr>
    <td class="thead">Timeframe</td>
    <td>
      From
    </td>
    <td>
      <select name="f_date_min">
      <?php
        f_datelist();
      ?>
      </select>
    </td>
    <td>
      Till
    </td>
    <td>
      <select name="f_date_max">
      <?php
        f_datelist();
      ?>
      </select>
    </td>
  </tr> 

  <tr>
    <td class="thead">Limit</td>
    <td>
      Type
    </td>
    <td>
      <select name="f_type">
	<option value="in/out"<?php if($f_type == "In/Out") echo "selected"; ?>>Total
	<option value="incoming"<?php if($f_type == "incoming") echo "selected"; ?>>Incoming
	<option value="outgoing"<?php if($f_type == "outgoing") echo "selected"; ?>>Outgoing
      </select>
    </td>
    <td></td>
    <td></td>
  </tr>
  
  <tr>
    <td class="thead">Peering Traffic</td>
    <td>
      Type
    </td>
    <td>
      <select name="f_peer">
	<option value="all"<?php if($f_peer == "all") echo "selected"; ?>>All Traffic
	<option value="onlypeer"<?php if($f_type == "onlypeer") echo "selected"; ?>>Only Peering Traffic
	<option value="nopeer"<?php if($f_type == "nopeer") echo "selected"; ?>>Without Peering Traffic
      </select>
    </td>
    <td></td>
    <td></td>
  </tr>  

  <tr>
    <td class="thead">Protocol</td>
    <td> 
    </td>
    <td>
      <select name="f_protocol">
        <option value="any">Any
        <option value="TCP"<?php if($f_protocol == "TCP") echo "selected"; ?>>TCP
        <option value="ICMP"<?php if($f_protocol == "ICMP") echo "selected"; ?>>ICMP
        <option value="UDP"<?php if($f_protocol == "UDP") echo "selected"; ?>>UDP
	<option value="OSPF"<?php if($f_protocol == "OSPF") echo "selected"; ?>>OSPF
      </select>
    </td>
    <td></td>
    <td></td>
  </tr>

  <tr>
    <td></td>
    <td></td>
    <td></td>
    <td></td>
    <td>
      <input type="submit" value="Calculate">
    </td>
  </tr>
</form>
</table>
<hr noshade size="1">
<?php
  // close database connection
  mysql_close($db_connection);
  // output the whole shit
  if ($action == "calculate")
    echo("$totaltraffic $f_type traffic of $f_protocol type for hostrange $f_host_start - $f_host_end in timerange $f_date_min - $f_date_max $cached<hr noshade size=\"1\">");
?>
<div class="small">
  <a href="http://www.nohn.net/projects/nacct-php/">Net Acct mySQL PHP 0.9.3</a> - execution time: <?php $total = round(getmicrotime()-$start,2); echo("$total"); ?>s
</div>
</body>
</html>

